---

.build_podman:
  variables:
    CONTAINER_RUNTIME: podman
    CONTAINER_IMAGE: quay.io/podman/stable:v3.4.2
    EE_NAME: ${DIRECTORY}
    FF_ENABLE_BASH_EXIT_CODE_CHECK: "true"
  image: $CONTAINER_IMAGE
  stage: build
  before_script:
    - echo "EE Name - $EE_NAME"
    - echo "Runtime - $CONTAINER_RUNTIME"
    - echo "Image - $CONTAINER_IMAGE"
    - $CONTAINER_RUNTIME login -u $CI_REGISTRY_USER -p $CI_JOB_TOKEN $CI_REGISTRY
    - |
      if [[ $CONTAINER_RUNTIME =~ ^docker.*$ ]]; then
        apk add python3 py3-pip \
        && pip3 install ansible-builder
      elif [[ $CONTAINER_RUNTIME =~ ^podman.*$ ]]; then
        dnf -y install python3-pip \
          python3-setuptools \
          python3-setuptools-rust \
          python3-wheel \
          && pip3 install ansible-builder
      else
        echo "$CONTAINER_RUNTIME must be either podman or docker"
        exit 1
      fi

  script:
    - cd $EE_NAME
    - ansible-builder build --container-runtime=$CONTAINER_RUNTIME -v 3 -f execution-environment.yml -t $CI_REGISTRY_IMAGE/$EE_NAME:$CI_COMMIT_SHA
    - $CONTAINER_RUNTIME push $CI_REGISTRY_IMAGE/$EE_NAME:$CI_COMMIT_SHA
    - |
      if [[ "$CI_COMMIT_BRANCH" == "$CI_DEFAULT_BRANCH" ]]; then
        echo "Running on $CI_DEFAULT_BRANCH branch so tagging as latest"
        $CONTAINER_RUNTIME tag $CI_REGISTRY_IMAGE/$EE_NAME:$CI_COMMIT_SHA $CI_REGISTRY_IMAGE/$EE_NAME:latest
        $CONTAINER_RUNTIME push $CI_REGISTRY_IMAGE/$EE_NAME:latest
      fi
  rules:
    - changes:
      - ${DIRECTORY}/*

.build_dind:
  variables:
    CONTAINER_RUNTIME: docker
    CONTAINER_IMAGE: docker:latest
  extends: .build_podman 
  services:
    - docker:dind
